<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '发起盘点',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '发起盘点' : '盘点详情'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #products>
          <div style="width: 100%">
            <el-button
              type="primary"
              @click="openProduct = true"
              style="margin-bottom: 10px"
            >
              添加物品
            </el-button>
            <el-table :data="formData.data.list">
              <el-table-column prop="name" label="物品编码" />
              <el-table-column prop="productName" label="物品名称" />
              <el-table-column prop="name" label="规格型号" />
              <el-table-column prop="name" label="单位" />
              <el-table-column prop="name" label="库存数量" />
              <el-table-column
                prop="checkQuantity"
                label="盘点数量"
                min-width="150"
              >
                <template #default="{ row, $index }">
                  <el-form-item
                    :prop="'list.' + $index + '.checkQuantity'"
                    :rules="rules.checkQuantity"
                    :inline-message="true"
                  >
                    <el-input-number
                      v-model="row.checkQuantity"
                      :precision="4"
                      :controls="false"
                      :min="0"
                    />
                  </el-form-item>
                </template>
              </el-table-column>
              <el-table-column prop="name" label="盘点结果" />
              <el-table-column prop="zip" label="操作" width="100">
                <template #default="{ $index }">
                  <el-button type="primary" link @click="handleRemove($index)"
                    >删除</el-button
                  >
                </template>
              </el-table-column>
            </el-table>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
    <el-dialog
      v-model="openProduct"
      title="选择物品"
      width="70%"
      append-to-body
    >
      <SelectGoods
        @cancel="openProduct = false"
        @pushGoods="pushGoods"
      ></SelectGoods>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
import useUserStore from "@/store/modules/user";
import SelectGoods from "@/components/product/SelectGoods";

const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let openProduct = ref(false);

let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  checkQuantity: [
    { required: true, message: "请输入盘点数量", trigger: "blur" },
  ],
  warehouseId: [
    { required: true, message: "请选择盘点仓库", trigger: "change" },
  ],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "盘点结论",
    prop: "type",
    data: [
      {
        label: "正常",
        value: "1",
      },

      {
        label: "异常",
        value: "2",
      },
    ],
  },
]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "盘点单号",
        prop: "code",
      },
    },
    {
      attrs: {
        label: "仓库名称",
        prop: "name",
      },
    },
    {
      attrs: {
        label: "盘点时间",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "盘点人",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "盘点结论",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "盘点物品数",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "正常物品数",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "异常物品数",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "接收",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "打印",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "select",
    prop: "warehouseId",
    label: "盘点仓库",
    itemWidth: 33,
    isLoad: {
      url: "/warehouse/page",
      req: {
        pageNum: 1,
        pageSize: 9999,
      },
      labelKey: "name",
      labelVal: "id",
      method: "post",
      resUrl: "rows",
    },
  },
  {
    type: "title",
    title: "盘点明细",
  },
  {
    type: "slot",
    slotName: "products",
    label: "",
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/stockCheck/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    list: [],
  };
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/stockCheck/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/productSpu/detail", { id: row.id }).then((res) => {
    res.list = res.productInfoList;
    formData.data = res;
    dialogVisible.value = true;
  });
};

getList();

const handleSelect = (row) => {
  const flag = formData.data.list.some((x) => x.id === row.id);
  if (flag)
    return ElMessage({
      message: "该物品已选择",
      type: "info",
    });
  formData.data.list.push({
    name: row.name,
    code: row.code,
    id: row.id,
  });
  return ElMessage({
    message: "选择成功",
    type: "success",
  });
};

const pushGoods = (goods) => {
  const arr = goods.map((x) => ({
    productId: x.id,
    checkQuantity: "",
    checkQuantity: "",
    productName: x.name,
    code: x.code,
  }));
  formData.data.list = formData.data.list.concat(arr);
  return ElMessage({
    message: "添加成功！",
    type: "success",
  });
};

const handleRemove = (index) => {
  formData.data.list.splice(index, 1);
  return ElMessage({
    message: "删除成功",
    type: "success",
  });
};
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>